<template>
  <div>
    <v-card class="card-contenido">
      <v-navigation-drawer
        class="d-inline-block"
        width="400px"
        v-model="drawerLeft"
        :mini-variant.sync="miniLeft"
        permanent
        v-resize="onResize"
        ref="navigationDrawerLeft"
      >
        <v-list-item class="px-2">
          <v-list-item-icon>
            <v-icon @click.stop="miniLeft = !miniLeft">
              <template v-if="!miniLeft"> mdi-eye-off-outline </template>
              <template v-else> mdi-eye-outline </template>
            </v-icon>
          </v-list-item-icon>
          <v-list-item-title class="font-weight-bold">
            <span @click.stop="miniLeft = !miniLeft">Ocultar</span>
          </v-list-item-title>
        </v-list-item>
        <v-divider></v-divider>
        <v-list-item class="px-2">
          <v-list-item-icon>
            <v-icon>mdi-book-information-variant</v-icon>
          </v-list-item-icon>
          <v-list-item-title class="font-weight-bold"
            >Información del documento</v-list-item-title
          >
        </v-list-item>
        <v-list-item v-if="!miniLeft" class="px-2">
          <v-card width="100%" outlined color="#e6e6e6" class="pa-5">
            <p class="font-weight-regular">
              <strong>Documentador:</strong><br />
              {{ folioDocumento.creador.nombre }}
            </p>
            <p class="font-weight-regular">
              <strong>Título:</strong><br />
              {{ folioDocumento.documento.titulo }}
            </p>
            <p class="font-weight-regular">
              <strong>Fecha de creación:</strong><br />
              {{ folioDocumento.fechaCreacion }}
            </p>
            <p class="font-weight-regular">
              <strong>Objetivo:</strong><br />
              {{ folioDocumento.documento.objetivo }}
            </p>
            <p class="font-weight-regular">
              <strong>Versión:</strong><br />
              {{ folioDocumento.documento.version }}
            </p>
            <p class="font-weight-regular">
              <strong>Control de cambios:</strong><br />
              {{ folioDocumento.documento.controlCambios }}
            </p>
          </v-card>
        </v-list-item>
        <v-divider></v-divider>
        <v-list-item v-if="!miniLeft" class="px-2">
          <v-row>
            <v-col class="text-center" :sm="12" :md="12" :lg="12" :xl="12">
              <strong>¿Qué acción realizarás?</strong>
            </v-col>
            <v-col class="pb-2" :sm="12" :md="12" :lg="12" :xl="12">
              <template v-if="folio.estado.idEstadoFolio == 3">
                <v-btn
                  class="rounded-0"
                  color="primary"
                  block
                  @click="isDialogRevisarDocumento = true"
                  >Autorizar</v-btn
                >
              </template>
              <template v-if="folio.estado.idEstadoFolio == 4">
                <v-btn
                  class="rounded-0"
                  color="primary"
                  block
                  @click="isDialogAutorizarDocumento = true"
                  >Autorizar</v-btn
                >
              </template>
            </v-col>
            <v-col class="pt-2">
              <v-btn
                class="rounded-0"
                dark
                color="grey darken-1"
                block
                @click="isDialogModificarDocumento = true"
                >Solicitar modificación</v-btn
              >
            </v-col>
            <v-col class="pt-0">
              <v-btn
                class="rounded-0"
                color="white"
                block
                @click="isDialogRechazarDocumento = true"
                >Rechazar documento</v-btn
              >
            </v-col>
          </v-row>
        </v-list-item>
        <v-divider></v-divider>
        <v-list-item class="px-2">
          <v-list-item-icon>
            <v-icon>mdi-format-list-text</v-icon>
          </v-list-item-icon>
          <v-list-item-title class="font-weight-bold"
            >Estructura del documento</v-list-item-title
          >
        </v-list-item>
        <v-list-item v-if="!miniLeft" class="px-2">
          <v-list-item-title class="font-weight-bold"
            >Modelo de negocio</v-list-item-title
          >
        </v-list-item>
        <v-list v-show="!miniLeft">
          <v-list-item-group v-model="archivoSelected" color="primary">
            <template v-for="(itemArchivo, index) in folioArchivosModelo">
              <v-divider :key="'divider-modelo-negocio' + index" />
              <v-list-item
                :value="itemArchivo"
                :key="'item-modelo-negocio' + index"
                link
              >
                <v-list-item-icon>
                  <v-icon>mdi-file</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title>{{
                    itemArchivo.nombre
                  }}</v-list-item-title>
                </v-list-item-content>
                <v-list-item-action>
                  <v-icon>mdi-chevron-right</v-icon>
                </v-list-item-action>
              </v-list-item>
            </template>
          </v-list-item-group>
        </v-list>
        <v-list-item v-if="!miniLeft" class="px-2">
          <v-list-item-title class="font-weight-bold"
            >Elementos contextuales</v-list-item-title
          >
        </v-list-item>
        <v-list v-show="!miniLeft">
          <v-list-item-group v-model="archivoSelected" color="primary">
            <template
              v-for="(itemArchivo, index) in folioArchivosModeloContextuales"
            >
              <v-divider :key="'divider-elemento-cotextual' + index" />
              <v-list-item
                :value="itemArchivo"
                :key="'item-elemento-cotextual' + index"
                link
              >
                <v-list-item-icon>
                  <v-icon>mdi-file</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title>{{
                    itemArchivo.nombre
                  }}</v-list-item-title>
                </v-list-item-content>
                <v-list-item-action>
                  <v-icon>mdi-chevron-right</v-icon>
                </v-list-item-action>
              </v-list-item>
            </template>
          </v-list-item-group>
        </v-list>
      </v-navigation-drawer>
      <div
        class="d-inline-block p-absolute visor-archivos"
        :style="'width:calc(100% - ' + navigationDrawerWidth + 'px);'"
      >
        <FolioVisorArchivo
          v-if="refreshVisorArchivo"
          :folio="folio"
          :archivo="archivoSelected"
        />
      </div>
    </v-card>
    <template>
      <v-dialog v-model="isDialogRevisarDocumento" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong
                >¿Revisar el documento: "{{
                  folioDocumento.documento.titulo
                }}"?</strong
              >
            </div>
          </v-card-title>
          <v-card-text>
            <p>
              Con esta revición el documento será enviado a autorización y los
              usuarios responsables podrán autorizar.
            </p>
            <strong>Agrega tus comentarios aquí (obligatorio)</strong>
            <v-textarea
              maxlength="250"
              rows="3"
              no-resize
              filled
              counter
              clearable
              v-model="comentariosFirma"
            >
            </v-textarea>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="grey darken-1"
                @click="isDialogRevisarDocumento = false"
                >Abandonar decisión</v-btn
              >
              <v-btn
                class="ma-2"
                :class="[
                  {
                    desac:
                      !comentariosFirma ||
                      (comentariosFirma && comentariosFirma.length < 10),
                  },
                ]"
                depressed
                dark
                tile
                color="primary"
                @click="cambiarEstadoFirma(2)"
                >Revisado</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog
        v-model="isDialogAutorizarDocumento"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong
                >¿Autorizar el documento: "{{
                  folioDocumento.documento.titulo
                }}"?</strong
              >
            </div>
          </v-card-title>
          <v-card-text>
            <p>
              Con esta autorización el documento será publicado y visualizado
              por los usuarios con acceso al mismo.
            </p>
            <strong>Agrega tus comentarios aquí (obligatorio)</strong>
            <v-textarea
              maxlength="250"
              rows="3"
              no-resize
              filled
              counter
              clearable
              v-model="comentariosFirma"
            >
            </v-textarea>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="grey darken-1"
                @click="isDialogAutorizarDocumento = false"
                >Abandonar decisión</v-btn
              >
              <v-btn
                class="ma-2"
                :class="[
                  {
                    desac:
                      !comentariosFirma ||
                      (comentariosFirma && comentariosFirma.length < 10),
                  },
                ]"
                depressed
                dark
                tile
                color="primary"
                @click="cambiarEstadoFirma(2)"
                >Autorizar documento</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog
        v-model="isDialogModificarDocumento"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong
                >Solicitar modificación al documento: "{{
                  folioDocumento.documento.titulo
                }}"?</strong
              >
            </div>
          </v-card-title>
          <v-card-text>
            <p>
              Se compartirán tus observaciones con el documentador para que las
              impacte.
            </p>
            <strong
              >Redacta las moficaciones que se deberán realizar
              (obligatorio)</strong
            >
            <v-textarea
              maxlength="250"
              rows="3"
              no-resize
              filled
              counter
              clearable
              v-model="comentariosFirma"
            >
            </v-textarea>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="grey darken-1"
                @click="isDialogModificarDocumento = false"
                >Abandonar decisión</v-btn
              >
              <v-btn
                class="ma-2"
                :class="[
                  {
                    desac:
                      !comentariosFirma ||
                      (comentariosFirma && comentariosFirma.length < 10),
                  },
                ]"
                depressed
                dark
                tile
                color="primary"
                @click="cambiarEstadoFirma(4)"
                >Solicitar modificación</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog
        v-model="isDialogRechazarDocumento"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong
                >¿Rechazas el documento: "{{
                  folioDocumento.documento.titulo
                }}"?</strong
              >
            </div>
          </v-card-title>
          <v-card-text>
            <p>Rechazar el documento detendrá la publicación del documento.</p>
            <strong
              >Coloca las motivantes para rechazar el documento
              (obligatorio)</strong
            >
            <v-textarea
              maxlength="250"
              rows="3"
              no-resize
              filled
              counter
              clearable
              v-model="comentariosFirma"
            >
            </v-textarea>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="grey darken-1"
                @click="isDialogRechazarDocumento = false"
                >Abandonar decisión</v-btn
              >
              <v-btn
                class="ma-2"
                :class="[
                  {
                    desac:
                      !comentariosFirma ||
                      (comentariosFirma && comentariosFirma.length < 10),
                  },
                ]"
                depressed
                dark
                tile
                color="primary"
                @click="cambiarEstadoFirma(3)"
                >Rechazar documento</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <v-dialog
        v-model="isDialogExitoAutorizacionDocumento"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>Documento autorizado exitosamente</strong>
            </div>
          </v-card-title>
          <v-card-text>
            <p>
              El documento ha sido autorizado de manera exitosa, esta decisión y
              tus comentarios serán compartidos con el documentador
            </p>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                :to="toBandeja"
                color="primary"
                @click="isDialogExitoAutorizacionDocumento = false"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <v-dialog
        v-model="isDialogExitoRevisionDocumento"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>Documento revisado exitosamente</strong>
            </div>
          </v-card-title>
          <v-card-text>
            <p>
              El documento ha sido revisado de manera exitosa, esta decisión y
              tus comentarios serán compartidos con el documentador
            </p>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                :to="toBandeja"
                @click="isDialogExitoRevisionDocumento = false"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <v-dialog
        v-model="isDialogExitoModificacionDocumento"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>Solicitud de modificación enviada exitosamente</strong>
            </div>
          </v-card-title>
          <v-card-text>
            <p>
              La solicitud de modificación y tus motivantes serán compartidos
              con el documentador
            </p>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                :to="toBandeja"
                color="primary"
                @click="isDialogExitoModificacionDocumento = false"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <v-dialog
        v-model="isDialogExitoRechazoDocumento"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>Documento rechazado exitosamente</strong>
            </div>
          </v-card-title>
          <v-card-text>
            <p>
              El documento ha sido rechazado de manera exitosa, esta decisión y
              sus motivantes serán compartidos con el documentador
            </p>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right: 0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                :to="toBandeja"
                color="primary"
                @click="isDialogExitoRechazoDocumento = false"
                >De acuerdo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<style scoped>
.nombre-archivo {
  position: absolute;
  width: 100%;
  top: 0px;
  display: inline-block;
}
.card-contenido {
  position: absolute;
  left: 10px;
  right: 0px;
  height: calc(100% - 96px);
}
.visor-archivos {
  top: 0px;
  overflow-y: auto;
  height: calc(100% - 0px);
}
.d-inline-block.v-navigation-drawer {
  overflow-y: auto;
  padding-bottom: 32px;
}
.p-absolute {
  position: absolute;
}
</style>
<script>
import store from "@/store";
import FolioVisorArchivo from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/resumen/componentes/FolioVisorArchivo.vue";
import moment from "moment";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Comonenet-FolioDetalle",
  components: {
    FolioVisorArchivo,
  },
  props: ["folio"],
  data() {
    return {
      isDialogRevisarDocumento: false,
      isDialogAutorizarDocumento: false,
      isDialogModificarDocumento: false,
      isDialogRechazarDocumento: false,
      isDialogExitoAutorizacionDocumento: false,
      isDialogExitoRevisionDocumento: false,
      isDialogExitoModificacionDocumento: false,
      isDialogExitoRechazoDocumento: false,
      isDialogFracasoAutorizacionDocumento: false,
      isDialogFracasoRevisionDocumento: false,
      isDialogFracasoRechazoDocumento: false,
      isDialogFracasoModificacionDocumento: false,
      drawerLeft: true,
      miniLeft: false,
      comentariosFirma: null,
      folioDocumento: {
        documento: {},
        creador: {},
        fechaCreacion: null,
      },
      refreshVisorArchivo: false,
      navigationDrawerWidth: 0,
      archivoSelected: null,
      folioArchivosModelo: [],
      folioArchivosModeloContextuales: [],
      toBandeja: {
        name: "modelo_negocio_bandeja_autorizacion",
      },
    };
  },
  watch: {
    archivoSelected(val, prev) {
      if (!val) {
        this.archivoSelected = prev;
      }
      this.refreshVisorArchivo = false;
      setTimeout(() => {
        this.refreshVisorArchivo = true;
      }, 50);
    },
    isDialogRevisarDocumento(val) {
      if (val) {
        this.comentariosFirma = null;
      }
    },
    isDialogModificarDocumento(val) {
      if (val) {
        this.comentariosFirma = null;
      }
    },
    isDialogRechazarDocumento(val) {
      if (val) {
        this.comentariosFirma = null;
      }
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  methods: {
    fechaFormat(fechaIn) {
      fechaIn = fechaIn.substr(0, 10);
      let parts_of_date = fechaIn.split("/");
      let output = new Date(
        +parts_of_date[2],
        parts_of_date[1] - 1,
        +parts_of_date[0]
      );
      let fecha = moment(output).format("DD/MM/yyyy");
      return fecha;
    },
    onResize(event) {
      let navigationDrawerWidth = this.$refs.navigationDrawerLeft;
      if (navigationDrawerWidth) {
        this.navigationDrawerWidth = navigationDrawerWidth.$el.clientWidth;
      }
    },
    getFolioDocumento() {
      const self = this;
      axios(
        "/modelo-negocio/folios/v1/busquedas/documentos/" + this.folio.idFolio
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let fechaCreacion = this.fechaFormat(data.resultado.fechaCreacion);
            data.resultado.fechaCreacion = fechaCreacion;
            self.folioDocumento = data.resultado;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {});
    },
    getFolioArchivosVirtuales() {
      const self = this;
      axios(
        "/modelo-negocio/folio-virtuales-archivos/v1/" +
          this.folio.idFolio +
          "/virtuales/archivos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            data.resultado.folioVirtualesArchivos.forEach((itemArchivo) => {
              if (itemArchivo.tipo == 1) {
                self.folioArchivosModelo.push(itemArchivo);
              } else {
                self.folioArchivosModeloContextuales.push(itemArchivo);
              }
            });
            self.archivoSelected = self.folioArchivosModelo[0];
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    cambiarEstadoFirma(idEstadoFirma) {
      const self = this;
      let body = {
        idEstadoFirma: idEstadoFirma,
      };
      axios
        .put(
          "/modelo-negocio/folio-firmas/v1/" +
            this.folio.idFolio +
            "/firmas/" +
            this.folio.firma.idFirma +
            "/estados",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.postComentarioFirma(idEstadoFirma);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
            self.checkError(idEstadoFirma);
          }
        });
    },
    postComentarioFirma(idEstadoFirma) {
      const self = this;
      let body = {
        comentario: this.comentariosFirma,
        idEstadoFirma: idEstadoFirma,
      };
      axios
        .post(
          "/modelo-negocio/comentarios-firma/v1/" +
            this.folio.idFolio +
            "/firmas/" +
            this.folio.firma.idFirma +
            "/comentarios",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.isDialogRevisarDocumento = false;
            self.isDialogAutorizarDocumento = false;
            self.isDialogModificarDocumento = false;
            self.isDialogRechazarDocumento = false;
            if (self.folio.estado.idEstadoFolio == 3) {
              if (idEstadoFirma == 2) {
                self.isDialogExitoRevisionDocumento = true;
              }
            }
            if (self.folio.estado.idEstadoFolio == 4) {
              if (idEstadoFirma == 2) {
                self.isDialogExitoAutorizacionDocumento = true;
              }
            }
            if (idEstadoFirma == 3) {
              self.isDialogExitoRechazoDocumento = true;
            }
            if (idEstadoFirma == 4) {
              self.isDialogExitoModificacionDocumento = true;
            }
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
            self.checkError(idEstadoFirma);
          }
        });
    },
    checkError(idEstadoFirma) {
      if (this.folio.estado.idEstadoFolio == 3) {
        if (idEstadoFirma == 2) {
          this.isDialogFracasoRevisionDocumento = true;
        }
      }
      if (this.folio.estado.idEstadoFolio == 4) {
        if (idEstadoFirma == 2) {
          this.isDialogFracasoAutorizacionDocumento = true;
        }
      }
      if (idEstadoFirma == 3) {
        this.isDialogFracasoRechazoDocumento = true;
      }
      if (idEstadoFirma == 4) {
        this.isDialogFracasoModificacionDocumento = true;
      }
    },
  },
  created() {
    this.getFolioArchivosVirtuales();
    this.getFolioDocumento();
  },
};
</script>
